var
DirectSearchCounter :       integer;
BowerMourCounter    :       Integer;

function DirectSearch(var s : string; var subs : string) : integer;
var
 m,n            :       byte;
 i,j            :       integer;
 result         :       integer;
begin
 DirectSearchCounter:=0;
 result:=0;
 m:=ord(subs[0]);
 n:=ord(s[0]);
 i:=-1;
 repeat i:=i+1; j:=1;
        while (j<=m) and (s[i+j] = subs[j]) do
        begin
             j:=j+1;
             DirectSearchCounter:=DirectSearchCounter+1;
        end;
        DirectSearchCounter:=DirectSearchCounter+1;
 until (j>=m+1) or (i>=n-m);
 if j=m+1 then result:=i+1;
 DirectSearch:=result;
end;

function BowerMourSearch(var s: string; var p: string) : integer;
var
 d              :       array[char] of byte;
 m,n            :       byte;
 i,j,k          :       integer;
 result         :       integer;
begin
 BowerMourCounter:=0;
 BowerMourSearch:=0;
 result:=0;
 m:=ord(p[0]);
 n:=ord(s[0]);
 for i:=0 to 255 do d[chr(i)]:=m;
 for j:=1 to m-1 do d[p[j]]:=m-j;
 i:=m; j:=m;
 while (j>0) and (i<=n) do
 begin
      j:=m; k:=i;
      while (j>0) and (s[k]=p[j]) do
      begin
           k:=k-1; j:=j-1;
           BowerMourCounter:= BowerMourCounter+1;
      end;
      i:=i+d[s[i]]
 end;
 if j=0 then result:=k+1;
 BowerMourSearch:=result;
end;

var
 s,subs,FileName :       string;
 i,c             :       integer;
 SearchFile      :       text;
begin
 write('Enter file name: ');
 readln(FileName);

 Assign(SearchFile, FileName);
 Reset(SearchFile);

 write('Search text: ');
 readln(subs);

 i:=0;
 c:=0;
 while((not eof(SearchFile))and(i=0)) do begin
            c:=c+1;
            readln(SearchFile, s);
            i:=DirectSearch(s,subs);
 end;
 writeln;
 writeln('Standart:');
 if (i<>0) then begin
    writeln('Str: "', s, '"');
    writeln('Str num: ', c, ', pos: ', i, ', comp. count: ', DirectSearchCounter);
 end else
     writeln('Not found!');
 close(SearchFile);

 Assign(SearchFile, FileName);
 Reset(SearchFile);

 i:=0;
 c:=0;
 while((not eof(SearchFile))and(i=0)) do begin
            c:=c+1;
            readln(SearchFile, s);
            i:=BowerMourSearch(s,subs);
 end;
 writeln;
 writeln('Bower Mour:');
 if (i<>0) then begin
    writeln('Str: "', s, '"');
    writeln('Str num: ', c, ', pos: ', i, ', comp. count: ', BowerMourCounter);
 end else
     writeln('Not found!');
end.
